function varargout = data_acquisition_v01(varargin)


% This GUI takes experimenters input as Metadata and extracts the .wfm file
% to .mat format.
% 
%
% Input parameters:
% Metadata as seen in the GUI
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Current state of the project and change history.
%
%	Created by:	R. Obaid
%	Created on:	08/09/2011
%
%	Version: 1.1
%	Modified by: R. Obaid
%	Edited on:	1. Removed baseline, maxsig from the data structure
%               2. Renamed time_array to time.
%	  
%
% If you type 'help data_acquisition_v01' on the Matlab command window, you
% will see the help documentaiton.
%





% DATA_ACQUISITION_V01 MATLAB code for data_acquisition_v01.fig
%      DATA_ACQUISITION_V01, by itself, creates a new DATA_ACQUISITION_V01 or raises the existing
%      singleton*.
%
%      H = DATA_ACQUISITION_V01 returns the handle to a new DATA_ACQUISITION_V01 or the handle to
%      the existing singleton*.
%
%      DATA_ACQUISITION_V01('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DATA_ACQUISITION_V01.M with the given input arguments.
%
%      DATA_ACQUISITION_V01('Property','Value',...) creates a new DATA_ACQUISITION_V01 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before data_acquisition_v01_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to data_acquisition_v01_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help data_acquisition_v01

% Last Modified by GUIDE v2.5 15-Aug-2011 15:20:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @data_acquisition_v01_OpeningFcn, ...
                   'gui_OutputFcn',  @data_acquisition_v01_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before data_acquisition_v01 is made visible.
function data_acquisition_v01_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to data_acquisition_v01 (see VARARGIN)

% Choose default command line output for data_acquisition_v01
handles.output = hObject;

% Update handles structure
handles.lightsource = 'Laser';
handles.ndfilter_1='0';
handles.ndfilter_2='0';
handles.data_type=1;
handles.data_source=1;
handles.position_scan=0;
handles.voltage_scan=0;

guidata(hObject, handles);

% UIWAIT makes data_acquisition_v01 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = data_acquisition_v01_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes on selection change in lightsource.
function lightsource_Callback(hObject, eventdata, handles)
% hObject    handle to lightsource (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns lightsource contents as cell array
%        contents{get(hObject,'Value')} returns selected item from lightsource

contents_lightsource=cellstr(get(hObject,'String'));

input_lightsource=contents_lightsource{get(hObject,'Value')};
handles.lightsource=input_lightsource;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function lightsource_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lightsource (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function up_light_intens_Callback(hObject, eventdata, handles)
% hObject    handle to up_light_intens (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of up_light_intens as text
%        str2double(get(hObject,'String')) returns contents of up_light_intens as a double
input_up_light_intens=str2double(get(hObject,'String'));

if (isnan(input_up_light_intens))
    errordlg('Enter a number','Up Stream Light Intensity','modal');
    uicontrol(hObject);
end

handles.up_light_intens=input_up_light_intens;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function up_light_intens_CreateFcn(hObject, eventdata, handles)
% hObject    handle to up_light_intens (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function down_light_intens_Callback(hObject, eventdata, handles)
% hObject    handle to down_light_intens (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of down_light_intens as text
%        str2double(get(hObject,'String')) returns contents of down_light_intens as a double

input_down_light_intens=str2double(get(hObject,'String'));

if (isnan(input_down_light_intens))
    errordlg('Enter a number','Downstream light intensity','modal');
    uicontrol(hObject);
    
elseif(isempty(input_down_light_intens))
    input_down_light_intens=0;
    set(hObject,'String','0');
end

handles.down_light_intens=input_down_light_intens;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function down_light_intens_CreateFcn(hObject, eventdata, handles)
% hObject    handle to down_light_intens (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function calc_intens_f_wheel_Callback(hObject, eventdata, handles)
% hObject    handle to calc_intens_f_wheel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of calc_intens_f_wheel as text
%        str2double(get(hObject,'String')) returns contents of calc_intens_f_wheel as a double
input_calc_intens_f_wheel=str2double(get(hObject,'String'));

if (isnan(input_calc_intens_f_wheel))
    errordlg('Enter a number for calculated intensity after wheel gap');
    uicontrol(hObject);
end

handles.calc_intens_f_wheel=input_calc_intens_f_wheel;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function calc_intens_f_wheel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to calc_intens_f_wheel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on selection change in ndfilter_1.
function ndfilter_1_Callback(hObject, eventdata, handles)
% hObject    handle to ndfilter_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns ndfilter_1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ndfilter_1

contents_nd1=cellstr(get(hObject,'String'));
input_nd1=str2num(contents_nd1{get(hObject,'Value')});

handles.ndfilter_1=input_nd1;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function ndfilter_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ndfilter_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in ndfilter_2.
function ndfilter_2_Callback(hObject, eventdata, handles)
% hObject    handle to ndfilter_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns ndfilter_2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from ndfilter_2
contents_nd2=cellstr(get(hObject,'String'));
input_nd2=str2num(contents_nd2{get(hObject,'Value')});

handles.ndfilter_2=input_nd2;
guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function ndfilter_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ndfilter_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function scope_scale_Callback(hObject, eventdata, handles)
% hObject    handle to scope_scale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of scope_scale as text
%        str2double(get(hObject,'String')) returns contents of scope_scale as a double
input_scope_scale=str2double(get(hObject,'String'));

if (isnan(input_scope_scale))
    errordlg('Enter a number','Scope Scale (mVolts)','modal');
    uicontrol(hObject);
end
handles.scope_scale=input_scope_scale;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function scope_scale_CreateFcn(hObject, eventdata, handles)
% hObject    handle to scope_scale (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function trig_source_Callback(hObject, eventdata, handles)
% hObject    handle to trig_source (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of trig_source as text
%        str2double(get(hObject,'String')) returns contents of trig_source as a double
input_trig_source=str2num(get(hObject,'String'));

if (isnan(input_trig_source))
    errordlg('Enter a number','Trigger Source','modal');
    uicontrol(hObject);
    
elseif(isempty(input_trig_source))
    errordlg('Enter a number','Trigger Source','modal');
    uicontrol(hObject);
    
elseif(input_trig_source<1 ||input_trig_source>4)
    errordlg('Enter a trigger source between 1 and 4 incl.');
    uicontrol(hObject);
end

handles.trig_source=input_trig_source;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function trig_source_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trig_source (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function mcp1_samp_lev_Callback(hObject, eventdata, handles)
% hObject    handle to mcp1_samp_lev (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mcp1_samp_lev as text
%        str2double(get(hObject,'String')) returns contents of mcp1_samp_lev as a double
input_mcp1_samp_lev=get(hObject,'String');

if(isempty(input_mcp1_samp_lev))
    input_mcp1_samp_lev='Not Specified';
    
end

handles.mcp1_samp_lev=input_mcp1_samp_lev;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function mcp1_samp_lev_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mcp1_samp_lev (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function mcp2_samp_lev_Callback(hObject, eventdata, handles)
% hObject    handle to mcp2_samp_lev (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mcp2_samp_lev as text
%        str2double(get(hObject,'String')) returns contents of mcp2_samp_lev as a double
input_mcp2_samp_lev=get(hObject,'String');

if(isempty(input_mcp2_samp_lev))
    input_mcp2_samp_lev='Not Specified';
end

handles.mcp2_samp_lev=input_mcp2_samp_lev;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function mcp2_samp_lev_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mcp2_samp_lev (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function trig_level_Callback(hObject, eventdata, handles)
% hObject    handle to trig_level (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of trig_level as text
%        str2double(get(hObject,'String')) returns contents of trig_level as a double
input_trig_level=str2double(get(hObject,'String'));

if isnan(input_trig_level)
    errordlg('Enter a number for the trigger level','Trigger Level','modal');
    uicontrol(hObject);
end
handles.trig_level=input_trig_level;
guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function trig_level_CreateFcn(hObject, eventdata, handles)
% hObject    handle to trig_level (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function anode_gap_Callback(hObject, eventdata, handles)
% hObject    handle to anode_gap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of anode_gap as text
%        str2double(get(hObject,'String')) returns contents of anode_gap as a double
input_anode_gap=str2double(get(hObject,'String'));

if (isnan(input_anode_gap))
    errordlg('Enter a number for anode gap','Anode gap','modal');
    uicontrol(hObject);
    
elseif(isempty(input_anode_gap))
    set(hObject,'String','0');
end

handles.anode_gap=input_anode_gap;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function anode_gap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to anode_gap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function inter_mcp_gap_Callback(hObject, eventdata, handles)
% hObject    handle to inter_mcp_gap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of inter_mcp_gap as text
%        str2double(get(hObject,'String')) returns contents of inter_mcp_gap as a double
input_mcp_gap=str2double(get(hObject,'String'));

if (isnan(input_mcp_gap))
    errordlg('Enter a number for anode gap','Inter MCP gap','modal');
    uicontrol(hObject);
    
elseif(isempty(input_mcp_gap))
    set(hObject,'String','0');
end

handles.inter_mcp_gap=input_mcp_gap;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function inter_mcp_gap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to inter_mcp_gap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pc_gap_Callback(hObject, eventdata, handles)
% hObject    handle to pc_gap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pc_gap as text
%        str2double(get(hObject,'String')) returns contents of pc_gap as a double
input_pc_gap=str2double(get(hObject,'String'));

if (isnan(input_pc_gap))
    errordlg('Enter a number for pc gap','PC gap','modal');
    uicontrol(hObject);
    
elseif(isempty(input_pc_gap))
    set(hObject,'String','0');
end

handles.pc_gap=input_pc_gap;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function pc_gap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pc_gap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function data_date_Callback(hObject, eventdata, handles)
% hObject    handle to data_date (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of data_date as text
%        str2double(get(hObject,'String')) returns contents of data_date as a double
input_data_date=get(hObject,'String');
handles.data_date=input_data_date;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function data_date_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_date (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on selection change in data_type.
function data_type_Callback(hObject, eventdata, handles)
% hObject    handle to data_type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns data_type contents as cell array
%        contents{get(hObject,'Value')} returns selected item from data_type

contents_data_type=cellstr(get(hObject,'String'));
contents_selected_type=contents_data_type{get(hObject,'Value')};

if strcmp(contents_selected_type,'Data')
    handles.data_type =1;
elseif strcmp(contents_selected_type,'MC')
    handles.data_type=0;
end
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function data_type_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_type (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in data_source.
function data_source_Callback(hObject, eventdata, handles)
% hObject    handle to data_source (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns data_source contents as cell array
%        contents{get(hObject,'Value')} returns selected item from data_source
contents_data_source=cellstr(get(hObject,'String'));
contents_selected_source=contents_data_source{get(hObject,'Value')};

if strcmp(contents_selected_source,'Scope')
    handles.data_source =1;
elseif strcmp(contents_selected_source,'Chip')
    handles.data_source=0;
end
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function data_source_CreateFcn(hObject, eventdata, handles)
% hObject    handle to data_source (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function num_of_chan_Callback(hObject, eventdata, handles)
% hObject    handle to num_of_chan (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of num_of_chan as text
%        str2double(get(hObject,'String')) returns contents of num_of_chan as a double
input_num_of_chan=str2double(get(hObject,'String'));

if (isnan(input_num_of_chan))
    errordlg('Enter a number','Number of Channels','modal');
    uicontrol(hObject);
end

handles.num_of_chan=input_num_of_chan;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function num_of_chan_CreateFcn(hObject, eventdata, handles)
% hObject    handle to num_of_chan (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% --- Executes on button press in voltage_scan.
function voltage_scan_Callback(hObject, eventdata, handles)
% hObject    handle to voltage_scan (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of voltage_scan
input_v=get(hObject,'Value');
if input_v == get(hObject,'Max')
    handles.voltage_scan=1;
else handles.voltage_scan=0;
end

guidata(hObject,handles);




% --- Executes on button press in position_scan.
function position_scan_Callback(hObject, eventdata, handles)
% hObject    handle to position_scan (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of position_scan

input_pos=get(hObject,'Value');
if input_pos == get(hObject,'Max')
    handles.position_scan=1;
else handles.position_scan=0;
end

guidata(hObject,handles);




% --- Executes on selection change in name_tag.
function name_tag_Callback(hObject, eventdata, handles)
% hObject    handle to name_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns name_tag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from name_tag
input=cellstr(get(hObject,'String'));
input_name_t=input{get(hObject,'Value')};

handles.name_tag=input_name_t;

guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function name_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to name_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function mcp_num_Callback(hObject, eventdata, handles)
% hObject    handle to mcp_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of mcp_num as text
%        str2double(get(hObject,'String')) returns contents of mcp_num as a double
input_mcp_num=str2num(get(hObject,'String'));

if (isnan(input_mcp_num))
    errordlg('Enter a number','MCP Number','modal');
    uicontrol(hObject);
    
elseif(isempty(input_mcp_num))
    errordlg('Enter a number','MCP Number','modal');
    uicontrol(hObject);
    
end
handles.mcp_num=input_mcp_num;

guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function mcp_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to mcp_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function ad_comment_Callback(hObject, eventdata, handles)
% hObject    handle to ad_comment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ad_comment as text
%        str2double(get(hObject,'String')) returns contents of ad_comment as a double
input_ad_comment=get(hObject,'String');
handles.ad_comment=input_ad_comment;
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function ad_comment_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ad_comment (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function wfm_dir_edit_Callback(hObject, eventdata, handles)
% hObject    handle to wfm_dir_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of wfm_dir_edit as text
%        str2double(get(hObject,'String')) returns contents of wfm_dir_edit as a double
handles.wfm_dir_edit=get(hObject,'String');
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function wfm_dir_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to wfm_dir_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function out_file_edit_Callback(hObject, eventdata, handles)
% hObject    handle to out_file_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of out_file_edit as text
%        str2double(get(hObject,'String')) returns contents of out_file_edit as a double
input_out_file=get(hObject,'String');
handles.out_file_edit=input_out_file;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function out_file_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to out_file_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function strip_num_Callback(hObject, eventdata, handles)
% hObject    handle to strip_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of strip_num as text
%        str2double(get(hObject,'String')) returns contents of strip_num as a double
input_strip_num=str2num(get(hObject,'String'));

handles.strip_num=input_strip_num;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function strip_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to strip_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function chan_map_Callback(hObject, eventdata, handles)
% hObject    handle to chan_map (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of chan_map as text
%        str2double(get(hObject,'String')) returns contents of chan_map as a double
input_chan_map=str2num(get(hObject,'String'));

handles.chan_map=input_chan_map;

guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function chan_map_CreateFcn(hObject, eventdata, handles)
% hObject    handle to chan_map (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton_acq.
function pushbutton_acq_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_acq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles

%Adding the .wfm file location to MATLAB's path

addpath(handles.wfm_dir_edit);
cd(handles.wfm_dir_edit);


%Acquiring metadata
Metadata=struct('mcp_2_bottom_voltage_Volts',[], 'mcp_2_top_voltage_Volts',[],...
    'mcp_1_bottom_voltage_Volts',[], 'mcp_1_top_voltage_Volts',[], 'PC_voltage_Volts',[], ...
    'lightsource',handles.lightsource,'position_in_mills',[],...
    'upstream_light_intensity_mWatt',handles.up_light_intens,...
    'downstream_light_intensity_nWatt',handles.down_light_intens, ...
    'ndfilter_1',handles.ndfilter_1, 'ndfilter_2',handles.ndfilter_2,...
    'calculated_intensity_after_filter_wheel_nW',handles.calc_intens_f_wheel,...
    'data_1_or_MC_0',handles.data_type, 'scope_1_or_chip_0',handles.data_source,...
    'scope_scale_in_mV',handles.scope_scale, 'trigger_source_CH_number',handles.trig_source,...
    'trigger_level_mV',handles.trig_level,'MCP_1_sample_number',handles.mcp1_samp_lev,...
    'MCP_2_sample_number',handles.mcp2_samp_lev, 'anode_gap_in_mm',handles.anode_gap,...
    'inter_MCP_gap_in_mm',handles.inter_mcp_gap, 'PC_gap_in_mm',handles.pc_gap,...
    'Strip_Number',handles.strip_num,'Channel_Map',handles.chan_map,'Scan_type',[]);





Metadescription=struct('Comment',handles.ad_comment,'Date_of_Acquisition',handles.data_date,...
    'Data_Conversion',date);
    


%Deciding on type of scan and acquiring pertinent information



Nframes=1000;




if handles.voltage_scan ==1
    %[f_name,notused,volt_data,n,same_v_index]=read_voltage_info(handles.wfm_dir_edit);
    
    [info_read]=read_voltage_info(handles.wfm_dir_edit,handles.name_tag,1);
    Metadata.Scan_type='volt_scan';

%Running the for loop for a set of run n
for i=1:info_read.unique_num
    
    if handles.mcp_num==1
        Metadata.mcp_1_bottom_voltage_Volts=info_read.unique_voltage(i,1);
        Metadata.mcp_1_top_voltage_Volts=info_read.unique_voltage(i,2);
        Metadata.PC_voltage_Volts=info_read.unique_voltage(i,3);
        midname=strcat(num2str(info_read.unique_voltage(i,1)),'_',num2str(info_read.unique_voltage(i,2)),...
            '_',num2str(info_read.unique_voltage(i,3)));
    
    elseif handles.mcp_num==2
        Metadata.mcp_2_bottom_voltage_Volts=info_read.unique_voltage(i,1);
        Metadata.mcp_2_top_voltage_Volts=info_read.unique_voltage(i,2);
        Metadata.mcp_1_bottom_voltage_Volts=info_read.unique_voltage(i,3);
        Metadata.mcp_1_top_voltage_Volts=info_read.unique_voltage(i,4);
        Metadata.PC_voltage_Volts=info_read.unique_voltage(i,5);
        
        midname=strcat(num2str(info_read.unique_voltage(i,1)),'_',num2str(info_read.unique_voltage(i,2)),...
            '_',num2str(info_read.unique_voltage(i,3)),'_',num2str(info_read.unique_voltage(i,4)),...
            '_',num2str(info_read.unique_voltage(i,5)));
    end
    
    if i==1
        start=1;
    else start=info_read.same_v_index(i-1)+1;
    end
    
    CH=struct('data',{},'time',{});
    max_scan=1;
    placeholder=0;
    for j=start:info_read.same_v_index(i)
        placeholder=placeholder+1;
        [ytest, t, info, ind_over, ind_under] = wfm2readframe(info_read.fName{j},1);
        [s1 s2] = size(ytest);
        
        yarray = zeros(Nframes,s1);

        for nf=1:Nframes
        
            [ysingle, t, info, ind_over, ind_under] = wfm2readframe(info_read.fName{j},nf); 
            yarray(nf,:)=ysingle;
   
        end
        
        ind=mod(j,handles.num_of_chan);
      
        if ind==0
            ind=max_scan * handles.num_of_chan;
        end
        
       
        placeholder
        
        if placeholder>handles.num_of_chan
            disp('Ok so far')
            CH(ind).data=cat(3,CH(ind).data,yarray);
            
            CH(ind).time=cat(3,CH(ind).time,t);
           
        else CH(ind).data=yarray;
            CH(ind).time=t;
        end
        
    end
    
    %midname=strcat(num2str(info_read.volt_data(i,1)),'_',num2str(volt_data(i,2)),'_',num2str(volt_data(i,3)),...
       %  '_',num2str(volt_data(i,4)),'_',num2str(volt_data(i,5)));
   
    fullname=strcat(handles.name_tag,'-',midname);   
    filename=strcat(handles.out_file_edit,'/',fullname,'.mat');
    save(filename,'Metadata','Metadescription','CH');
                
        
        
    
    
end
end



if handles.position_scan==1
    [info_read]=read_voltage_info(handles.wfm_dir_edit,handles.name_tag,2);
    Metadata.Scan_type='pos_scan';
    
    if handles.mcp_num==1
        Metadata.mcp_1_bottom_voltage_Volts=info_read.unique_voltage(1,1);
        Metadata.mcp_1_top_voltage_Volts=info_read.unique_voltage(1,2);
        Metadata.PC_voltage_Volts=info_read.unique_voltage(1,3);
        midname=strcat(num2str(info_read.unique_voltage(1,1)),'_',num2str(info_read.unique_voltage(1,2)),...
            '_',num2str(info_read.unique_voltage(1,3)));
    
    elseif handles.mcp_num==2
        Metadata.mcp_2_bottom_voltage_Volts=info_read.unique_voltage(1,1);
        Metadata.mcp_2_top_voltage_Volts=info_read.unique_voltage(1,2);
        Metadata.mcp_1_bottom_voltage_Volts=info_read.unique_voltage(1,3);
        Metadata.mcp_1_top_voltage_Volts=info_read.unique_voltage(1,4);
        Metadata.PC_voltage_Volts=info_read.unique_voltage(1,5);
        midname=strcat(num2str(info_read.unique_voltage(1,1)),'_',num2str(info_read.unique_voltage(1,2)),...
            '_',num2str(info_read.unique_voltage(1,3)),'_',num2str(info_read.unique_voltage(1,4)),...
            num2str(info_read.unique_voltage(1,5)));
        
    end

%Running the for loop for a set of run n
for i=1:info_read.unique_num
    
    Metadata.position_in_mills=info_read.unique_pos(i);
    
    if i==1
        start=1;
    else start=info_read.same_pos_index(i-1)+1;
    end
    
    CH=struct('data',{},'time',{});
    max_scan=1;
    placeholder=0;
    for j=start:info_read.same_pos_index(i)
        placeholder=placeholder+1;
        [ytest, t, info, ind_over, ind_under] = wfm2readframe(info_read.fName{j},1);
        [s1 s2] = size(ytest);
        
        yarray = zeros(Nframes,s1);

        for nf=1:Nframes
        
            [ysingle, t, info, ind_over, ind_under] = wfm2readframe(info_read.fName{j},nf); 
            yarray(nf,:)=ysingle;
   
        end
        
        ind=mod(j,handles.num_of_chan);
      
        if ind==0
            ind=max_scan * handles.num_of_chan;
        end
        
       
        placeholder
        
        if placeholder>handles.num_of_chan
            disp('Ok so far')
            CH(ind).data=cat(3,CH(ind).data,yarray);
            
            CH(ind).time=cat(3,CH(ind).time,t);
           
        else CH(ind).data=yarray;
            CH(ind).time=t;
        end
        
    end
    
    lastname=strcat(num2str(info_read.unique_pos(i,1)),'_',num2str(info_read.unique_pos(i,2)),'_','mill');
    full_name=strcat(handles.name_tag,'-',midname,'-',lastname);
            
    filename=strcat(handles.out_file_edit,'/',full_name,'.mat');
    save(filename,'Metadata','Metadescription','CH');
                
        
        
    
    
end





end









disp('Complete');





guidata(hObject,handles);
